#Space Stations
#CvFinalFrontierEvents.py

#	Installation:
#		1. Open CvFinalFrontier.py using your preferred editor
#		2. Search for the line below in onEndGameTurn():
#			"#self.updateAllStarbases()"
#		3. Uncomment that line by removing the "#" in front of it.
#		4. Search for the line below:
#			"#Space station plugin (AI) goes here"
#		5. Overwrite that line with the code below:

		apUnitList = pyPlayer.getUnitList()
		for pyUnit in apUnitList:
			iType = pyUnit.getUnitType()
			pUnitInfo = gc.getUnitInfo(iType)
			if ((pUnitInfo.isStarbase()) and (not pUnitInfo.isOtherStation())):
				AI.doStarbaseAI(pyUnit)

#		6. Search for the line below:
#			#Space station plugin goes here
#		7. Overwrite that line with the following code (yes, ALL of it):

	def updateStarbaseCulture(self, iPlayer, iX, iY):
		
		# Create culture around unit
		for iXLoop in range(iX-2, iX+3):
			for iYLoop in range(iY-2, iY+3):
				iActiveX = iXLoop
				iActiveY = iYLoop
				if CyMap().isWrapX():
					if (iActiveX < 0):
						iActiveX = CyMap().getGridWidth() + iActiveX
				if CyMap().isWrapY():
					if (iActiveY < 0):
						iActiveY = CyMap().getGridHeight() + iActiveY
				pLoopPlot = CyMap().plot(iActiveX, iActiveY)
				printd("Setting Player %d as the owner of %d, %d" %(iPlayer, iXLoop, iYLoop))
				# Don't override culture that's already here
				if not pLoopPlot.isNone():
					if (pLoopPlot.getOwner() == -1):
						pLoopPlot.setOwnerNoUnitCheck(iPlayer)
		
	def updateAllStarbases(self):
	
		# List made to preserve culture of units built first
		aaiStarbaseList = []
		
		for iPlayerLoop in range(gc.getMAX_CIV_PLAYERS()):
			pPlayer = gc.getPlayer(iPlayerLoop)
			pTeam = gc.getTeam(pPlayer.getTeam())
			pyPlayer = PyPlayer(iPlayerLoop)
			
			iUnitToCreate = -1
			aiPossibleUnitList = self.getPossibleUnitList()
			
			if not gc.getGame().isOption(gc.getInfoTypeForString("GAMEOPTION_NO_STARBASE_MISSILES")):
				for iUnitLoop in aiPossibleUnitList:
					pUnitInfo = gc.getUnitInfo(iUnitLoop)
					iNeededTech = pUnitInfo.getPrereqAndTech()
					if (pTeam.isHasTech(iNeededTech)):
						iUnitToCreate = iUnitLoop
			
			apUnitList = pyPlayer.getUnitList()
			for pUnitLoop in apUnitList:
				if (pUnitLoop.isStarbase() and (not pUnitLoop.isOtherStation())):
					aaiStarbaseList.append([pUnitLoop.getGameTurnCreated(), iPlayerLoop, pUnitLoop.getX(), pUnitLoop.getY()])

					# Need appropriate tech to create Missile
					if (iUnitToCreate != -1):
						# Need appropriate turn to create
						iTurnCreated = pUnitLoop.getGameTurnCreated()
						iCurrentTurn = CyGame().getGameTurn()
						
						if (iTurnCreated != iCurrentTurn):
							iTurnsSinceCreation = iCurrentTurn - iTurnCreated
							# Produce Missile every self.iStarbaseMissileTurns turns
							if (iTurnsSinceCreation % self.iStarbaseMissileTurns == 0):
								print "UnitID: %d, X: %d, Y: %d" %(iUnitToCreate, pUnitLoop.getX(), pUnitLoop.getY())
								pUnit = pPlayer.initUnit(iUnitToCreate, pUnitLoop.getX(), pUnitLoop.getY(), UnitAITypes.NO_UNITAI, DirectionTypes.NO_DIRECTION)
								# Load Missile onto Starbase... the C++ doesn't like this but it can deal :)
								pUnit.setTransportUnit(pUnitLoop)
		
		printd("\n\nXXX: There are %d Starbases on the map" %(len(aaiStarbaseList)))
		printd(aaiStarbaseList)
			
		if (len(aaiStarbaseList) > 0):
			
			# Make order such that units built first get culture preference
			aaiStarbaseList.sort()
			
			for iStarbaseLoop in range(len(aaiStarbaseList)):
				self.updateStarbaseCulture(aaiStarbaseList[iStarbaseLoop][1], aaiStarbaseList[iStarbaseLoop][2], aaiStarbaseList[iStarbaseLoop][3])

		
	def getPossibleUnitList(self):
		aiPossibleUnitList = []
		for iUnitLoop in range(gc.getNumUnitInfos()):
			pUnitInfo = gc.getUnitInfo(iUnitLoop)
			if pUnitInfo.isMissile():
				aiPossibleUnitList.append(iUnitLoop)
		return aiPossibleUnitList